<id>
More Board and Category Options SP1.1
</id>

<version>
2.0
</version>

<mod info>
The mod gives you a new link on the admin-Center - "More Options for Boards/Categories", which allows you to:
	1. Password protect boards
	2. Set an icon for every board/category which will be displayed on the BoardIndex
	3. Define which membergroups/users are allowed to start topics, post replies, and view topics for each board of your forum.


Points to take into consideration:

	~ When a user logs into a password protected board, it sets a cookie to say access has been granted. This cookie is deleted when the user logs out or after a certain time limit has expired (which is set using the standard "Default Length for login cookies to last" admin setting). 
	~ Guests can log into password protected boards, but they do not have a logout option, so the cookie will remain active until the time limit expires! 
	~ Enter usernames and membergroups into the appropriate boxes in comma, seperated, lists. Please note that these are CaSe SeNsItIvE! Post dependant membergroups can also be used. (This is compatible with Add-More-Membergroups.) 
	~ Membergroups are specified using the same text that is defined in the "Edit Membergroups" admin area to be displayed in the users posts and profile, except for Administrators and Global Moderators which use "Administrator" and "Global Moderator" regardless of what text is displayed. In other words, if you set "YaBB Newbies" to be displayed as "Learner", you enter "Learner" into the MBCO text box, but if you set "YaBB Administrator" to be displayed as "Top Dog", you enter "Administrator" into the MBCO text box.
	~ You can also use "all", "members" and "moderator" as membergroups, to specify all users, all members or all moderators (of that board).
	~ Administrators are immune to all password or access checks, Global Moderators aren't! 
	~ When entering Catagory and Board picures, you can enter just a filename and extention if the file is in your YaBB Images directory, If the file is stored anywhere else, you can enter the URL or path relative to the YaBB.pl file. 
	~ You can use both this mod and the announcement boards mod, but why would you want to! 
	~ You may have noticed the new look admin panel in this version - just use the drop down selector to choose which catagory/board you want to edit, then wait for the information to load! 
	~ If both user and membergroup text boxes are empty for a function such as post, reply, or view, it is assumed that all users have FULL access to that function for that board!


Instructions:

	1. If you have NOT installed a previous version of this mod, skip ahead to step 5
	2. Write down your current MBCO settings
	3. Uninstall the previous version of the mod
	4. Delete all existing .mbo and all .mco files from your boards folder
	5. Put the images included in the zip file into your yabbimages directory
	6. Put the new MBCOptions.pl into your sources directory
	7. Install the mod using boardmod and upload the modified files (read http://boardmod.yabbforum.com/faq.php if you do not know how to install mods)
	8. Use the new MBCO admin panel to re-apply your settings :)
</mod info>

<author>
Omario, BHRA Webmaster (Based on a mod by cae)
</author>

<homepage>
http://www.clickopedia.com, http://www.bhra.org.uk
</homepage>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
        - <a href="$cgi;action=manageboards">$txt{'4'}</a>
</search for>

<replace>
        - <a href="$cgi;action=manageboards">$txt{'4'}</a><br>
        - <a href="$cgi;action=morebcoptions">$mbco{'1'}</a><br>
</replace>

<edit file>
YaBB.pl
</edit file>

<search for>
		elsif ($action eq 'modifyboard') { require "$sourcedir/ManageBoards.pl"; &ModifyBoard; }
</search for>

<add after>
		elsif ($action eq 'morebcoptions') { require "$sourcedir/MBCoptions.pl"; &MoreBCOptions; }
</add after>

<search for>
		elsif ($action eq 'ml') { require "$sourcedir/Admin.pl"; &ml; }
</search for>

<add after>
		elsif ($action eq 'mbcomodify')    { require "$sourcedir/MBCoptions.pl"; &mbcomodify; }
</add after>

<search for>
	elsif ($action eq 'clean_log') { require "$sourcedir/Admin.pl"; &clean_log; }
</search for>

<add after>
	elsif ($action eq 'checkboardpw') {require "$sourcedir/MBCoptions.pl"; &checkboardpw; }
</add after>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		unless( $openmemgr{$curcat} ) { next; }
		$yymain .= qq~<tr>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> <font size=2><b>$catname{$curcat}</b></font></a></td>
</search for>

<replace>
		unless( $openmemgr{$curcat} ) { next; }
		####
		if ($catpic{$curcat} =~ /\//i) {$catpic{$curcat} = qq~ <img src="$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		elsif ($catpic{$curcat}) {$catpic{$curcat} = qq~ <img src="$imagesdir/$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		####
		$yymain .= qq~<tr>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size="2"><b>$catname{$curcat}</b></font></a></td>
</replace>

<search for>
			$lastposttime ||= $txt{'470'};
</search for>

<add after>
			####
			$boardpic = "";
			if (-e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }
			if ($boardpic{$curboard} =~ /\//i) {$boardpic{$curboard} = qq~ <img src="$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}
			elsif ($boardpic{$curboard}) {$boardpic{$curboard} = qq~ <img src="$imagesdir/$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}

			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $boardpwpic = "";
			if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;}
			elsif ($boardpw{$curboard}) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;}
			####
</add after>

<search for>
        <font size=2><a href="$scripturl?board=$curboard"><B>$curboardname</B></a></font>
</search for>

<replace>
        <font size=2><a href="$scripturl?board=$curboard">$boardpic{$curboard}<B>$curboardname $boardpwpic</B></a></font>
</replace>

<search for>
			fopen(FILE, "$boardsdir/$curboard.dat");
</search for>

<add before>
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "1") {next;}
</add before>

<edit file>
english.lng
</edit file>

<search for>
1;
</search for>

<replace>
$mbco{'1'} = "More Board/Category Options";
$mbco{'2'} = "Lets you:<li>Password protect boards</li><li>Select an individual image for each board/category</li><li>Specify who can post/reply and start new topics in a board!<br>Images for boards and categories must be placed in your Yabb Images directory located <a href=$imagesdir>here</a>. <br> Enjoy working with this mod!";
$mbco{'3'} = "Password";
$mbco{'4'} = "Pic";
$mbco{'5'} = "Set category pic";
$mbco{'6'} = "Apply Changes";
$mbco{'7'} = "Set board pic";
$mbco{'8'} = "Current pic:";
$mbco{'9'} = "Enter password";
$mbco{'10'} = "Submit";
$mbco{'11'} = "for the board";
$mbco{'12'} = "Wrong password!";
$mbco{'13'} = "This Post cannot be displayed because it is in a protected board which you do not have permission to access";
$mbco{'14'} = "[Not Available]";
$mbco{'15'} = "Board is password-protected. You have to be logged in to log in this board!";
$mbco{'16'} = "Membergroups";
$mbco{'17'} = "who can start topics:";
$mbco{'18'} = "who can reply:";
$mbco{'19'} = "who can view:";
$mbco{'20'} = "Show boards unable to be viewed on Board Index?";
$mbco{'21'} = "Catagory Options";
$mbco{'22'} = "Board Options";
$mbco{'23'} = "Give this category a picture that will be displayed before it's name";
$mbco{'24'} = "Set a password for this board";
$mbco{'25'} = "Give this board a picture to be displayed before the board's name";
$mbco{'26'} = "Specify which Users can start topics in this board";
$mbco{'27'} = "Specify which Membergroups can start topics in this board";
$mbco{'28'} = "Specify which Users can reply to topics in this board";
$mbco{'29'} = "Specify which Membergroups can reply to topics in this board";
$mbco{'30'} = "Specify which Users can view topics in this board";
$mbco{'31'} = "Specify which Membergroups can view topics in this board";
$mbco{'32'} = "If this option is selected, boards that are unable to be viewed by users will still be shown on boardindex but not allowed to be entered.";

1;
</replace>

<edit file>
Sources/Search.pl
</edit file>

<search for>
		fopen(FILE, "$boardsdir/$curboard.txt") || next;
		@threads = <FILE>;
		fclose(FILE);
</search for>

<add after>
		####
		unless ($settings[7] eq "Administrator") {
			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $access = &AccessCheck($curboard, '');
			if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
		}
		####
</add after>

<search for>
		boardcheck: foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
</search for>

<add after>
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		boardcheck: foreach $curboard (@{$catboards{$curcat}}) {
</search for>

<add after>
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
</add after>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
		foreach $curboard (@catboards ) {
			chomp $curboard;
</search for>

<add after>
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
</add after>

<search for>
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);
</search for>

<add after>
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
</add after>

<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
	$username = 'Guest';
</search for>

<add before>
	####
	while( $tmpboard = each(%boardpw) ) {
		unless( $tmpboard ) { next; }
		my $cookiename = "$cookiepassword$tmpboard";
		if ($yyCookies{$cookiename}) {
			push @otherCookies, cookie(-name    =>   "$cookiename",
						   -value   =>   "",
						   -path    =>   "/",
						   -expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
			$yyCookies{$cookiename} = '';
		}
	}
	####
</add before>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
$pwseed ||= 'yy';
</search for>

<add before>
$currentcat = $INFO{'cat'};
if ($currentcat =~ m~/~){ &fatal_error($txt{'399a'}); }
if ($currentcat =~ m~\\~){ &fatal_error($txt{'400a'}); }
if ($currentcat ne '' && $currentcat !~ /\A[\s0-9A-Za-z#%+,-\.:=?@^_]+\Z/){ &fatal_error($txt{'399a'}); }

</add before>

<search for>
$cgi = qq~$scripturl?board=$currentboard~;
</search for>

<replace>
if ($currentcat ne "") {$cgi = qq~$scripturl?cat=$currentcat~;}
else {$cgi = qq~$scripturl?board=$currentboard~;}

if ($currentboard && -e "$boardsdir/$currentboard.mbo" ) { require "$boardsdir/$currentboard.mbo"; }
if (-e "$vardir/boards.pwd") {require "$vardir/boards.pwd";}
if (-e "$vardir/cat.mco") {require "$vardir/cat.mco";}
</replace>

<search for>
	if($yySetCookies1 || $yySetCookies2) { print header(-cookie=>[$yySetCookies1, $yySetCookies2], -charset=>'$yycharset'); }
	else { print header(-status=>'200 OK', -charset=>'$yycharset'); }
</search for>

<replace>
	if($yySetCookies1 || $yySetCookies2 || scalar @otherCookies) { print header(-cookie=>[$yySetCookies1, $yySetCookies2, @otherCookies], -charset=>'$yycharset'); }
	else { print header(-status=>'200 OK', -charset=>'$yycharset'); }
</replace>

<edit file>
Sources/Load.pl
</edit file>

<search for>
		foreach(split(/\|/,$yyBoardInfo[2])) {
			fopen(MODERATOR, "$memberdir/$_.dat");
			@modprop = <MODERATOR>;
			fclose(MODERATOR);
			$modprop[1] =~ s/[\n\r]//g;
			$moderators{$_} = $modprop[1];
		}
</search for>

<add after>
		####	
		unless ($settings[7] eq "Administrator") {
			my $accesstype = "";
			my $cookiename = "$cookiepassword$currentboard";
			my $crypass = crypt($boardpw{$currentboard},$pwseed);
			if ($boardpw{$currentboard} && $yyCookies{$cookiename} ne $crypass && !$FORM{'boardpw'} ) { require "$sourcedir/MBCoptions.pl"; &askforboardpw("$currentboard"); }
			if ($action eq "post") { $accesstype = $INFO{'num'} ? 2 : 1; }
			my $access = &AccessCheck($currentboard, $accesstype);
			if ($access ne "granted"){ &fatal_error($txt{'1'});}
		}
		####

</add after>

<edit file>
Sources/Security.pl
</edit file>

<search for>
1;
</search for>

<add before>
sub AccessCheck{
	my ($curboard, $checktype) = @_;
	if ($curboard ne $currentboard && -e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }

	fopen(FILE, "$memberdir/$username.dat");
		@memsettings=<FILE>;
	fclose(FILE);

	if(!$MemStatAdmin) {
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
	}

	# Load Membergroups
	chomp $memsettings[7];
	if ($username eq "Guest"){ $memberinfo = ""; }
	elsif ($memsettings[7] ne "") { $memberinfo = $memsettings[7]; }
	else {
		if ($MemStatAdmin) {
			$msstatcount = "0";
			if( $memsettings[6] >= $MemPostNewbie) {$memberinfo = "$MemStatNewbie";}
			while($MemStat[$msstatcount]) {
				if( $memsettings[6] >= $MemPostNum[$msstatcount] && $MemPostNum[$msstatcount] ne "x") {$memberinfo = "$MemStat[$msstatcount]";}
				++$msstatcount;
			}
		} else {
			if($memsettings[6] > $GodPostNum) { $memberinfo = $membergroups[6]; }
			elsif($memsettings[6] > $SrPostNum) { $memberinfo = $membergroups[5]; }
			elsif($memsettings[6] > $FullPostNum) { $memberinfo = $membergroups[4]; }
			elsif($memsettings[6] > $JrPostNum) { $memberinfo = $membergroups[3]; }
			else { $memberinfo = $membergroups[2]; }
		}
	}
	chomp $memberinfo;

	my $access = "denied";
	if ($checktype == 1){ # Post access check
		@allowed_users = split(/,/,$start_users{$curboard});
		@allowed_groups = split(/,/,$start_groups{$curboard});
		if ($start_users{$curboard} eq "" && $start_groups{$curboard} eq "") {$access = "granted";}  
	} elsif ($checktype == 2){ # Reply access check
		@allowed_users = split(/,/,$reply_users{$curboard});
		@allowed_groups = split(/,/,$reply_groups{$curboard});
		if ($reply_users{$curboard} eq "" && $reply_groups{$curboard} eq "") {$access = "granted";}  
	} else { # Board access check
		@allowed_users = split(/,/,$view_users{$curboard});
		@allowed_groups = split(/,/,$view_groups{$curboard});
		if ($view_users{$curboard} eq "" && $view_groups{$curboard} eq "") {$access = "granted";}  
	}

	unless ($access eq "granted") {
 		foreach $user (@allowed_users) {
			chomp $user;
  			if ($user eq $username) {$access = "granted"; last;}  
 		} 
	}
	unless ($access eq "granted") {
 		foreach $element (@allowed_groups) {
			chomp $element;
			if ($element eq "all") {$access = "granted"; last;} 
			if ($element eq "members" && $username ne "Guest"){$access = "granted"; last;}
			if ($element eq $memberinfo) {$access = "granted"; last;} 
			if ($element eq "moderator" && ($memsettings[7] eq 'Administrator' || $memsettings[7] eq 'Global Moderator' || exists $moderators{$username})) {$access = "granted"; last;}
		}
	}

	return ($access);
}

</add before>

<edit file>
Sources/MoveThread.pl
</edit file>

<search for>
		foreach $curboard (@catinfo) {
			$curboard =~ s/[\n\r]//g;
</search for>

<add after>
			####
			unless ($settings[7] eq "Administrator") {
				my $cookiename = "$cookiepassword$curboard";
				my $crypass = crypt($boardpw{$curboard},$pwseed);
				my $access = &AccessCheck($curboard, '');
				if (($boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) || ($access ne "granted")) { next; }
			}
			####
</add after>