<id>
Rebuild Message Index SP1/1.1
</id>

<version>
1.01
</version>

<mod info>
This mod adds an admin function to rebuild damaged message index files. It does this by storing the id of the board each thread is on in the data file for that thread. By reading this information, YaBB can determine which board to place the threads on when rebuilding the index files for each board.


Features:
 - Checkbox board selection, to determine which boards to rebuild.
 - Threads on rebuilt boards are sorted into the default order (most recently replied to thread first).
 - Update function to set the current board location for all existing threads.
 - Any thread which doesn't have it's current location stored, can be placed in a nominated "orphan" board.


To install:
 - Apply the mod normally, and upload all modified files to the appropriate directories.
 - Upload the RebuildIndex.pl file to your YaBB/Sources directory, and chmod it the same as the other files.
 - Place the board in Maintainance Mode if it isn't already.
 - Click on the new "Rebuild Message Index" link in the Admin center, and follow the instructions to set the current location of each thread.


Notes:
 - This function will only work in Maintainance Mode.
 - Unless you use the update function when first installing this mod, the rebuild function will place ALL threads in the SAME nominated "orphan" board.
 - If you are using any mods which add information to the Message Index files or Thread data files, this information may be lost unless you install the appropriate patch file.

</mod info>

<author>
BHRA Webmaster
</author>

<homepage>
http://www.bhra.org.uk
</homepage>

#############################################################################################################

<edit file>
english.lng
</edit file>

<search for>
$txt{'593'} = "Rebuild Members List";
</search for>

<add after>
$txt{'593a'} = "Rebuild Message Index";
</add after>

#############################################################################################################

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'rebuildmemlist') { require "$sourcedir/Admin.pl"; &RebuildMemList; }
</search for>

<add after>
	elsif ($action eq 'rmi_index') { require "$sourcedir/RebuildIndex.pl"; &RMI_index; }
	elsif ($action eq 'rmi_recover') { require "$sourcedir/RebuildIndex.pl"; &RMI_recover; }
	elsif ($action eq 'rmi_set') { require "$sourcedir/RebuildIndex.pl"; &RMI_set; }
</add after>

#############################################################################################################

<edit file>
Sources\Admin.pl
</edit file>

<search for>
        <td bgcolor="$color{'catbg'}" height="19" class="catbg"><img src="$imagesdir/board.gif" alt="" border="0"> <font size="2"><b>$txt{'501'}</b></td>
      </tr><tr>
        <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="1">
</search for>

<add after>
        - <a href="$cgi;action=rmi_index">$txt{'593a'}</a><br>
</add after>

#############################################################################################################

<edit file>
Sources\Display.pl
</edit file>

<search for>
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		fclose(FILE);
	}
</search for>

<replace>
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		@other_stuff = <FILE>;
		fclose(FILE);
		chomp $tmpa;
	}
</replace>

<search for>
	fclose(FILE);
	$views = $tmpa - 1;
</search for>

<add before>
	print FILE qq~\n~;
	print FILE @other_stuff;
</add before>

#############################################################################################################

<edit file>
Sources\LockThread.pl
</edit file>

<search for>
		} else { fclose(BOARDFILE); &fatal_error("$txt{'93'}"); }
</search for>

<add before>
			fopen(FILE, "$datadir/$threadid.data");
			$tmpa = <FILE>;
			$tmpb = <FILE>;
			$tmpc = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
			chomp $tmpb;
			fopen(FILE, "+>$datadir/$threadid.data") || &fatal_error("103 $txt{'106'}: $txt{'23'} $threadid.data");
			print FILE qq~$tmpa\n~;
			print FILE qq~$tmpb\n~;
			print FILE qq~$mstate\n~;
			print FILE @other_stuff;
			fclose(FILE);
</add before>

#############################################################################################################

<edit file>
Sources\MessageIndex.pl
</edit file>

<search for>
		if( fopen(FILE, "$datadir/$mnum.data") ) {
			$tmpa = <FILE>;
			fclose(FILE);
		}
</search for>

<replace>
		if(fopen(FILE, "$datadir/$mnum.data")) {
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
		}
</replace>

#############################################################################################################

<edit file>
Sources\ModifyMessage.pl
</edit file>

<search for>
					fopen(FILE, "$datadir/$tnum2.data");
					$tmpa = <FILE>;
					fclose(FILE);
</search for>

<replace>
					fopen(FILE, "$datadir/$tnum2.data");
					$tmpa = <FILE>;
					@other_stuff = <FILE>;
					fclose(FILE);
					chomp $tmpa;
</replace>

<search for>
				fopen(FILE, "$datadir/$tnum.data");
				$tmpa = <FILE>;
				fclose(FILE);
</search for>

<replace>
				fopen(FILE, "$datadir/$tnum.data");
				$tmpa = <FILE>;
				@other_stuff = <FILE>;
				fclose(FILE);
				chomp $tmpa;
</replace>


<search for>
				fclose(FILE);
			}
			$messages[$postid] = '';
</search for>

<add before>
				print FILE qq~\n~;
				print FILE @other_stuff;
</add before>

#############################################################################################################

<edit file>
Sources\MoveThread.pl
</edit file>

<search for>
			fopen(FILE, "$datadir/$mnuma.data");
			$tmpa = <FILE>;
			fclose(FILE);
</search for>

<replace>
			fopen(FILE, "$datadir/$mnuma.data");
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
</replace>

<search for>
				fopen(FILE, "$datadir/$thread.$1");
				@fileinfo = <FILE>;
				fclose(FILE);
</search for>

<add after>
				if ($1 eq 'data') {
					chomp $fileinfo[0]; $fileinfo[0] = qq~$fileinfo[0]\n~;
					$fileinfo[1] = qq~$toboard\n~;
				}
</add after>

<search for>
			fopen(FILE, "$datadir/$mobilenum.data");
			$tmpa = <FILE>;
			fclose(FILE);
</search for>

<replace>
			fopen(FILE, "$datadir/$mobilenum.data");
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
</replace>


#############################################################################################################

<edit file>
Sources\Post.pl
</edit file>

<search for>
	fopen(FILE2, "$datadir/$thread.data");
	$tempinfo = <FILE2>;
	fclose(FILE2);
</search for>

<replace>
	fopen(FILE2, "$datadir/$thread.data");
	$tempinfo = <FILE2>;
	@other_stuff = <FILE2>;
	fclose(FILE2);
	chomp $tempinfo;
	$other_stuff[0] = qq~$currentboard\n~;
</replace>

<search for>
	fclose(FILE2);
}
</search for>

<add before>
	print FILE2 qq~\n~;
	print FILE2 @other_stuff;
</add before>


#############################################################################################################

<edit file>
Sources\RemoveThread.pl
</edit file>

<search for>
			fopen(FILE, "$datadir/$mnum2.data");
			$tmpa = <FILE>;
			fclose(FILE);
</search for>

<replace>
			fopen(FILE, "$datadir/$mnum2.data");
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
</replace>

#############################################################################################################

<edit file>
Sources\Subs.pl
</edit file>

<search for>
		fopen(FILEBTTL, "$datadir/$postid.data");
		$tmpa = <FILEBTTL>;
		fclose(FILEBTTL);
</search for>

<replace>
		fopen(FILEBTTL, "$datadir/$postid.data");
		$tmpa = <FILEBTTL>;
		@other_stuff = <FILEBTTL>;
		fclose(FILEBTTL);
		chomp $tmpa;
</replace>