<ID>
Reserve Usernames/Names Mod
</ID>

<version>
1.1x
</version>

Revision:
1.0 10/20/00 First release as .txt file
1.1 10/25/00 Release as .mod file, add case and match options.
1.1x11/01/00 small bug fixed by [CV]XXL

Installation Difficulty:
Medium

<Mod info>
Allows the administrator to reserve names and words to prevent them from being used in member's usernames and/or display names.  Includes options to match whole word or partial, match case or not. 
</Mod info>

Thanks to Sharp at dphage.com for his Case Insensitive Username mod which inspired this mod and which I partly copied for the username screen part.

How to use the mod once installed:
Login as admin and go to the admin section.  You will see a new option after Set censored words called Set reserved names.  Click on this and a window will open similar to the word censor window.  Enter all reserved names/words in this window, one per line.  Select options for match to username and/or name, whole word or partial and match case or not.  Click Save.  Now any words entered should be screened in the username and/or name fields when a person registers.  Also includes check of display name when modifying profiles.
Note that it will write two new files to the variables directory, reserve.txt and reservecfg.txt.

<Author>
David Gross
</Author>

<Homepage> 
http://www.cafetropico.com
</Homepage>

<Edit file>
YaBB.pl
</Edit file>

<Search for>
if ($action eq "mltop") { require "$sourcedir/Memberlist.pl"; &MLTop; }
</Search for>

<Add after>
if ($action eq "setreserve") { require "$sourcedir/Admin.pl"; &SetReserve; }
if ($action eq "setreserve2") { require "$sourcedir/Admin.pl"; &SetReserve2; }
</Add after>

<Edit file>
Sources\Admin.pl
</Edit file>

<Search for>
<a href="$cgi&action=setcensor">$txt{'135'}</a><br>
</Search for>

<Add after>
<a href="$cgi&action=setreserve">Set reserved names</a><br>
</Add after>

<Search for>

1;
</Search for>

<Add before>
sub SetReserve {
	# Only allow Adminstrators to access the admin
	if($settings[7] ne "Administrator") { &fatal_error("$txt{'1'}"); }
	open(FILE, "$vardir/reserve.txt") || open(FILE, ">$vardir/reserve.txt");
	&lock(FILE);
	@reserved = <FILE>;
	&unlock(FILE);
	close(FILE);
	open(FILE, "$vardir/reservecfg.txt") || open(FILE, ">$vardir/reservecfg.txt");
	&lock(FILE);
	@reservecfg = <FILE>;
	&unlock(FILE);
	close(FILE);
	$title = "Set Reserved Names";
	$reservecfg[0] =~ s/\n//g;
	$reservecfg[1] =~ s/\n//g;
	$reservecfg[2] =~ s/\n//g;
	$reservecfg[3] =~ s/\n//g;
	$reservecfg[0] =~ s/\r//g;
	$reservecfg[1] =~ s/\r//g;
	$reservecfg[2] =~ s/\r//g;
	$reservecfg[3] =~ s/\r//g;

	&header;
	print <<"EOT";
<table border=0 width=100% cellspacing=1 bgcolor="#000000">
<tr>
	<td bgcolor="$color{'titlebg'}"><font face="$face" size=2 color="$color{'titletext'}"><b>Set Reserved Names</b></font></td>
</tr>
<tr>
	<td bgcolor="$color{'windowbg'}"><font face="$face" size=2><form action="$cgi&action=setreserve2" method="POST">One word per line.<br>
	<textarea cols=60 rows=6 name="reserved" style="width:100%">
EOT
	foreach $cur (@reserved) {
		print "$cur";
	}
	print <<"EOT";
	</textarea><br>
	<font size=2><input type=checkbox name="matchword" value="checked" $reservecfg[0]></font>
	<font size=2><b>Match whole word only</b></font><br>
	<font size=2><input type=checkbox name="matchcase" value="checked" $reservecfg[1]></font>
	<font size=2><b>Match exact case</b></font><br>
	<font size=2><input type=checkbox name="matchuser" value="checked" $reservecfg[2]></font>
	<font size=2><b>Match Username</b></font><br>
	<font size=2><input type=checkbox name="matchname" value="checked" $reservecfg[3]></font>
	<font size=2><b>Match Name</b></font><br>	
	<input type=submit value="$txt{'10'}"></form></font></td>
</tr>
</table>
EOT
	&footer;
	exit;
}

sub SetReserve2 {
	# Only allow Adminstrators to access the admin
	if($settings[7] ne "Administrator") { &fatal_error("$txt{'1'}"); }
	open(FILE, ">$vardir/reserve.txt");
	&lock(FILE);
	print FILE "$FORM{'reserved'}";
	&unlock(FILE);
	close(FILE);
	open(FILE, ">$vardir/reservecfg.txt");
	&lock(FILE);
	print FILE "$FORM{'matchword'}\n";
	print FILE "$FORM{'matchcase'}\n";
	print FILE "$FORM{'matchuser'}\n";
	print FILE "$FORM{'matchname'}\n";	
	&unlock(FILE);
	close(FILE);	
	print "Location: $cgi\&action=admin\n\n";
	exit;
}
</Add before>

<Edit file>
Sources\Register.pl
</Edit file>

<Search for>
	open(FILE, ">$memberdir/$FORM{'username'}.dat");
</Search for>

<Add before>
	open(FILE, "$vardir/reserve.txt");
	&lock(FILE);
	@reserve = <FILE>;
	&unlock(FILE);
	close(FILE);
	open(FILE, "$vardir/reservecfg.txt");
	&lock(FILE);
	@reservecfg = <FILE>;
	&unlock(FILE);
	close(FILE);
	$reservecfg[0] =~ s/\n//g;
	$reservecfg[1] =~ s/\n//g;
	$reservecfg[2] =~ s/\n//g;
	$reservecfg[3] =~ s/\n//g;
	$reservecfg[0] =~ s/\r//g;
	$reservecfg[1] =~ s/\r//g;
	$reservecfg[2] =~ s/\r//g;
	$reservecfg[3] =~ s/\r//g;
	$matchword = $reservecfg[0];
	$matchcase = $reservecfg[1];
	$matchuser = $reservecfg[2];
	$matchname = $reservecfg[3];		
	if ($matchcase ne "checked") { 
	    $usercheck = lc $FORM{'username'};
		$namecheck = lc $FORM{'name'};
	}
	else {
	    $usercheck = $FORM{'username'};
		$namecheck = $FORM{'name'};
	}
	
	foreach $reserved (@reserve) {
		$reserved =~ s/\n//g;
		$reserved =~ s/\r//g;
		if ($matchcase eq "checked") { $reservecheck = $reserved; }
	   	    else { $reservecheck = lc $reserved; }
		if ($matchuser eq "checked") {
		    if ($matchword eq "checked") { 
			    if ($usercheck eq $reservecheck && $settings[7] ne "Administrator") { &fatal_error("The username you tried to register contains reserved name $reserved. Please try another username."); }
			}
			else {
				if ($usercheck =~ $reservecheck && $settings[7] ne "Administrator") { &fatal_error("The username you tried to register contains reserved name $reserved. Please try another username."); }
			} 
		}
		if ($matchname eq "checked") {
			if ($matchword eq "checked") { 
			    if ($namecheck eq $reservecheck && $settings[7] ne "Administrator") { &fatal_error("The name you tried to register contains reserved name $reserved. Please try another name."); }
			}
			else {
				if ($namecheck =~ $reservecheck && $settings[7] ne "Administrator") { &fatal_error("The name you tried to register contains reserved name $reserved. Please try another name."); }
			} 
		}
	}
</Add before>
	
<Edit file>
Sources\Profile.pl
</Edit file>

<Search for>
	&fatal_error("$txt{'76'}") if($FORM{'email'} eq "");
</Search for>

<Add after>
	open(FILE, "$vardir/reserve.txt");
	&lock(FILE);
	@reserve = <FILE>;
	&unlock(FILE);
	close(FILE);
	open(FILE, "$vardir/reservecfg.txt");
	&lock(FILE);
	@reservecfg = <FILE>;
	&unlock(FILE);
	close(FILE);
	$reservecfg[0] =~ s/\n//g;
	$reservecfg[1] =~ s/\n//g;
	$reservecfg[2] =~ s/\n//g;
	$reservecfg[3] =~ s/\n//g;
	$reservecfg[0] =~ s/\r//g;
	$reservecfg[1] =~ s/\r//g;
	$reservecfg[2] =~ s/\r//g;
	$reservecfg[3] =~ s/\r//g;
	$matchword = $reservecfg[0];
	$matchcase = $reservecfg[1];
	$matchuser = $reservecfg[2];
	$matchname = $reservecfg[3];		
	if ($matchcase ne "checked") { 
		$namecheck = lc $FORM{'name'};
	}
	else {
		$namecheck = $FORM{'name'};
	}
	
	foreach $reserved (@reserve) {
		$reserved =~ s/\n//g;
		$reserved =~ s/\r//g;
		if ($matchcase eq "checked") { $reservecheck = $reserved; }
	   	    else { $reservecheck = lc $reserved; }
		if ($matchname eq "checked") {
			if ($matchword eq "checked") { 
			    if ($namecheck eq $reservecheck && $settings[7] ne "Administrator") { &fatal_error("The name you tried to register contains reserved name $reserved. Please try another name."); }
			}
			else {
				if ($namecheck =~ $reservecheck && $settings[7] ne "Administrator") { &fatal_error("The name you tried to register contains reserved name $reserved. Please try another name."); }
			} 
		}
	}
</Add after>

